"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var program = require("commander");
program
    .command('build')
    .description('Generate the masket key and the encrypted secrets')
    .action(function () {
    require('./build');
});
program
    .command('start')
    .description('Start to developer with auto deploy and watchers')
    .action(function () {
    require('./start');
});
program
    .command('stop')
    .description('Stop all dapp-stack process, in case there is zombies')
    .action(function () {
    require('./stop');
});
program
    .command('test')
    .description('Run the contracts tests')
    .action(function () {
    require('./test');
});
program
    .command('deploy')
    .description('Deploy the contracts and the assets')
    .action(function () {
    require('./deploy');
});
program
    .command('security')
    .description('Run security check on the contracts (require docker)')
    .action(function () {
    require('./security');
});
program
    .command('clean')
    .description('Remove all DApp Stack temporary directories')
    .action(function () {
    require('./clean');
});
program
    .command('console')
    .description('Start a geth console')
    .action(function () {
    require('./console');
});
program.parse(process.argv);
var showHelp = program.args.length === 0;
if (showHelp) {
    program.help();
}
//# sourceMappingURL=index.js.map